RoseGuilds = {
    name            = "RoseGuilds",
    author          = "@Kay.Cee",
}

RoseGuilds.savedVars = {
	firstLoad = true,
    accountWide = true,
	MidnightHidden = false,
	SpringHidden = false,
	SummerHidden = false,
	AutumnHidden = false,
	WinterHidden = false,
	RoseMenuHidden = false,
	xCoord = 175,
	mrxCoord = 210,
	sprxCoord = 240,
	srxCoord = 275,
	arxCoord = 310,
	wrxCoord = 345,
}

function MidnightHall()
	local accountName = GetDisplayName()
    if accountName == "@QueenMisi" then
        RequestJumpToHouse(47)
    else
        JumpToSpecificHouse("@QueenMisi", 47)
    end
end

function SpringHall()
	local accountName = GetDisplayName()
    if accountName == "@QueenMisi" then
        RequestJumpToHouse(47)
    else
        JumpToSpecificHouse("@QueenMisi", 47)
    end
end

function SummerHall()
	local accountName = GetDisplayName()
    if accountName == "@SuriValkyrie" then
        RequestJumpToHouse(94)
    else
        JumpToSpecificHouse("@SuriValkyrie", 94)
    end 
end

function AutumnHall()
	local accountName = GetDisplayName()
    if accountName == "@Kay.Cee" then
        RequestJumpToHouse(54)
    else
        JumpToSpecificHouse("@Kay.Cee", 54)
    end
end

function WinterHall()
	local accountName = GetDisplayName()
    if accountName == "@BellaBlithely" then
        RequestJumpToHouse(41)
    else
        JumpToSpecificHouse("@BellaBlithely", 41)
    end
end


--Roses
function RoseGuilds_Initialize(eventCode, addOnName)
	if (addOnName ~= "RoseGuilds") then return end
-------------------------------------------------------------------------------------------------------------------------------------------	
	if RoseGuilds.savedVars.xCoord == nil then RoseGuilds.savedVars.xCoord = 175 end 
	if RoseGuilds.savedVars.mrxCoord == nil then RoseGuilds.savedVars.mrxCoord = 210 end 
	if RoseGuilds.savedVars.sprxCoord == nil then RoseGuilds.savedVars.sprxCoord = 240 end 
	if RoseGuilds.savedVars.srxCoord == nil then RoseGuilds.savedVars.srxCoord = 275 end 
	if RoseGuilds.savedVars.arxCoord == nil then RoseGuilds.savedVars.arxCoord = 310 end 
	if RoseGuilds.savedVars.wrxCoord == nil then RoseGuilds.savedVars.wrxCoord = 345 end 

	local function savePosition()
	RoseGuildsMenuChat:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, RoseGuilds.savedVars.xCoord, 8) 
	end

	local Midnight = WINDOW_MANAGER:CreateTopLevelWindow()
	Midnight =  WINDOW_MANAGER:CreateControl("MidnightGuildHall", ZO_ChatWindow, CT_BUTTON)
	Midnight:SetDimensions(25, 25)
	Midnight:SetHandler("OnMouseEnter", function(control) InitializeTooltip(InformationTooltip, control) SetTooltipText(InformationTooltip, "|c6a5acdQueenMisi's Guildhall|r") end)
	Midnight:SetHandler("OnMouseExit", function(control) ClearTooltip(InformationTooltip) end)
	Midnight:SetHandler("OnClicked", function() MidnightHall() end)
	Midnight:SetNormalTexture("RoseGuilds/imgs/Midnight.dds")
	Midnight:SetHidden(RoseGuilds.savedVars.MidnightHidden)
	Midnight:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, RoseGuilds.savedVars.mrxCoord, 10)
	
	Spring =  WINDOW_MANAGER:CreateControl("SpringGuildHall", ZO_ChatWindow, CT_BUTTON)
    Spring:SetDimensions(25, 25)
    Spring:SetHandler("OnMouseEnter", function(control) InitializeTooltip(InformationTooltip, control) SetTooltipText(InformationTooltip, "|c00ff7fQueenMisi's Guildhall|r") end)
    Spring:SetHandler("OnMouseExit", function(control) ClearTooltip(InformationTooltip) end)
    Spring:SetHandler("OnClicked", function() SpringHall() end)
    Spring:SetNormalTexture("RoseGuilds/imgs/Spring.dds")
	Spring:SetHidden(RoseGuilds.savedVars.SpringHidden)
    Spring:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, RoseGuilds.savedVars.sprxCoord, 10) if Midnight:IsHidden() then Spring:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, RoseGuilds.savedVars.xCoord + 35, 10) end

	Summer =  WINDOW_MANAGER:CreateControl("SummerGuildHall", ZO_ChatWindow, CT_BUTTON)
	Summer:SetDimensions(25, 25)
    Summer:SetHandler("OnMouseEnter", function(control) InitializeTooltip(InformationTooltip, control) SetTooltipText(InformationTooltip, "|cf10000SuriValkyrie's Guildhall|r") end)
    Summer:SetHandler("OnMouseExit", function(control) ClearTooltip(InformationTooltip) end)
	Summer:SetHandler("OnClicked", function() SummerHall() end)
    Summer:SetNormalTexture("RoseGuilds/imgs/Summer.dds")
	Summer:SetHidden(RoseGuilds.savedVars.SummerHidden)
	Summer:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, RoseGuilds.savedVars.srxCoord, 10) if Midnight:IsHidden() then Summer:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, RoseGuilds.savedVars.xCoord + 35, 10) end
	
	Autumn =  WINDOW_MANAGER:CreateControl("AutumnGuildHall", ZO_ChatWindow, CT_BUTTON)
    Autumn:SetDimensions(25, 25)
    Autumn:SetHandler("OnMouseEnter", function(control) InitializeTooltip(InformationTooltip, control) SetTooltipText(InformationTooltip, "|cff4500Kay.Cee's Guildhall|r") end)
    Autumn:SetHandler("OnMouseExit", function(control) ClearTooltip(InformationTooltip) end)
    Autumn:SetHandler("OnClicked", function() AutumnHall() end)
    Autumn:SetNormalTexture("RoseGuilds/imgs/Autumn.dds")
	Autumn:SetHidden(RoseGuilds.savedVars.AutumnHidden)
    Autumn:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, RoseGuilds.savedVars.arxCoord, 10) if Midnight:IsHidden() then Autumn:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, RoseGuilds.savedVars.xCoord + 35, 10) end
	
	Winter =  WINDOW_MANAGER:CreateControl("WinterGuildHall", ZO_ChatWindow, CT_BUTTON)
    Winter:SetDimensions(25, 25)
    Winter:SetHandler("OnMouseEnter", function(control) InitializeTooltip(InformationTooltip, control) SetTooltipText(InformationTooltip, "|c1e90ffBellaBlithely's Guildhall|r") end)
    Winter:SetHandler("OnMouseExit", function(control) ClearTooltip(InformationTooltip) end)
    Winter:SetHandler("OnClicked", function() WinterHall() end)
    Winter:SetNormalTexture("RoseGuilds/imgs/Winter.dds")
	Winter:SetHidden(RoseGuilds.savedVars.WinterHidden)
    Winter:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, RoseGuilds.savedVars.wrxCoord, 10) if Midnight:IsHidden() then Winter:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, RoseGuilds.savedVars.xCoord + 35, 10) end

--Single Rose options	
local function hideAllExcept(showSingleRose)
    local SingleRoses = {
        {var = 'MidnightHidden', element = Midnight},
        {var = 'WinterHidden', element = Winter},
        {var = 'SummerHidden', element = Summer},
        {var = 'SpringHidden', element = Spring},
        {var = 'AutumnHidden', element = Autumn}
    }

    for i, item in ipairs(SingleRoses) do
        if item.element ~= showSingleRose then
            RoseGuilds.savedVars[item.var] =  item.element:SetHidden(true)
			RoseGuilds.savedVars[item.var] = not RoseGuilds.savedVars[item.var]
        else
            RoseGuilds.savedVars[item.var] =  item.element:SetHidden(false)
			RoseGuilds.savedVars[item.var] = RoseGuilds.savedVars[item.var]
            item.element:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, RoseGuilds.savedVars.xCoord + 35, 10)
        end
    end
end

local function MidnightToggle()
    hideAllExcept(Midnight)
end

local function SpringToggle()
    hideAllExcept(Spring)
end

local function SummerToggle()
    hideAllExcept(Summer)
end

local function AutumnToggle()
    hideAllExcept(Autumn)
end

local function WinterToggle()
    hideAllExcept(Winter)
end

local function MenuToggle()
    hideAllExcept(nil)
end

--Reset
local function ResetRoses()
    local SingleRoses = {
        {var = 'MidnightHidden', element = Midnight},
        {var = 'SpringHidden', element = Spring},
        {var = 'SummerHidden', element = Summer},
        {var = 'AutumnHidden', element = Autumn},
        {var = 'WinterHidden', element = Winter}
    }

    for i, item in ipairs(SingleRoses) do
        RoseGuilds.savedVars[item.var] = item.element:SetHidden(false)
        item.element:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, 210 + 30 * (i - 1), 10)
    end

    RoseGuildsMenuChat:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, 175, 8)
    RoseGuilds.savedVars.xCoord = 175
	Midnight:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, RoseGuilds.savedVars.mxCoord, 10)
	RoseGuilds.savedVars.mrxCoord = 210
	RoseGuilds.savedVars.sprxCoord = 240
	RoseGuilds.savedVars.srxCoord = 270
	RoseGuilds.savedVars.arxCoord = 300
	RoseGuilds.savedVars.wrxCoord = 330
end

SLASH_COMMANDS["/midnight"] = MidnightToggle
SLASH_COMMANDS["/winter"] = WinterToggle
SLASH_COMMANDS["/summer"] = SummerToggle
SLASH_COMMANDS["/spring"] = SpringToggle
SLASH_COMMANDS["/autumn"] = AutumnToggle
SLASH_COMMANDS["/rosemenu"] = MenuToggle
SLASH_COMMANDS["/resetroses"] = ResetRoses

local LAM = LibAddonMenu2
local panelName = "RoseGuildsPanel"
--settings
local panelData = {
    type = "panel",
    name = "|c1e90ffRose|cFFFFFFGuilds",
    author = "|c1e90ffKay.Cee",
	registerForRefresh = true,
}
local panel = LAM:RegisterAddonPanel(panelName, panelData)
local optionsData = {}
table.insert(
	optionsData,
    {
        type = "button",
        name = "|c6a5acdMidnight Rose",
		tooltip = "Only shows the Rose Menu & Midnight Rose buttons in the chat window",
        func = function() MidnightToggle() end
    })
table.insert(
	optionsData,
    {
        type = "button",
        name = "|c00ff7fSpring Rose",
		tooltip = "Only shows the Rose Menu & Spring Rose buttons in the chat window",
        func = function() SpringToggle() end
    })	
table.insert(
	optionsData,
    {
        type = "button",
        name = "|cf10000Summer Rose",
		tooltip = "Only shows the Rose Menu & Summer Rose buttons in the chat window",
        func = function() SummerToggle() end
    })	
table.insert(
	optionsData,
    {
        type = "button",
        name = "|cff4500Autumn Rose",
		tooltip = "Only shows the Rose Menu & Autumn Rose buttons in the chat window",
        func = function() AutumnToggle() end
    })	
table.insert(
	optionsData,
    {
        type = "button",
        name = "|c1e90ffWinter Rose",
		tooltip = "Only shows the Rose Menu & Winter Rose buttons in the chat window",
        func = function() WinterToggle() end
    })	
table.insert(
	optionsData,
    {
        type = "button",
        name = "|cffffffRoseGuilds Menu",
		tooltip = "Only shows the RoseGuild Menu button in the chat window",
        func = function() MenuToggle() end
    })
table.insert(
	optionsData,
    {
        type = "button",
        name = "|cFFFFFFReset Roses",
		tooltip = "Show all roses and reset their position in the chat window",
        func = function() ResetRoses() end
    })
table.insert(
	optionsData,
    {
        type = "slider",
        name = "|cFFFFFFRoseMenu position (Default 175)",
        getFunc = function() return RoseGuilds.savedVars.xCoord end,
        setFunc = function(value) RoseGuilds.savedVars.xCoord = value 
		RoseGuildsMenuChat:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, RoseGuilds.savedVars.xCoord, 8)
		end,
        min = 0,
        max = GuiRoot:GetWidth(),
        step = 1,
        width = "full",
    })
table.insert(
	optionsData,
    {
        type = "slider",
        name = "|cFFFFFFMidnight position (Default 210)",
        getFunc = function() return RoseGuilds.savedVars.mrxCoord end,
        setFunc = function(value) RoseGuilds.savedVars.mrxCoord = value 
		Midnight:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, RoseGuilds.savedVars.mrxCoord, 10)
		end,
        min = 0,
        max = GuiRoot:GetWidth(),
        step = 1,
        width = "full",
    })
table.insert(
	optionsData,
    {
        type = "slider",
        name = "|cFFFFFFSpring position (Default 240)",
        getFunc = function() return RoseGuilds.savedVars.sprxCoord end,
        setFunc = function(value) RoseGuilds.savedVars.sprxCoord = value 
		Spring:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, RoseGuilds.savedVars.sprxCoord, 10)
		end,
        min = 0,
        max = GuiRoot:GetWidth(),
        step = 1,
        width = "full",
    })
table.insert(
	optionsData,
    {
        type = "slider",
        name = "|cFFFFFFSummer position (Default 270)",
        getFunc = function() return RoseGuilds.savedVars.srxCoord end,
        setFunc = function(value) RoseGuilds.savedVars.srxCoord = value 
		Summer:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, RoseGuilds.savedVars.srxCoord, 10)
		end,
        min = 0,
        max = GuiRoot:GetWidth(),
        step = 1,
        width = "full",
    })
table.insert(
	optionsData,
    {
        type = "slider",
        name = "|cFFFFFFAutumn position (Default 300)",
        getFunc = function() return RoseGuilds.savedVars.arxCoord end,
        setFunc = function(value) RoseGuilds.savedVars.arxCoord = value 
		Autumn:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, RoseGuilds.savedVars.arxCoord, 10)
		end,
        min = 0,
        max = GuiRoot:GetWidth(),
        step = 1,
        width = "full",
    })
table.insert(
	optionsData,
    {
        type = "slider",
        name = "|cFFFFFFWinter position (Default 330)",
        getFunc = function() return RoseGuilds.savedVars.wrxCoord end,
        setFunc = function(value) RoseGuilds.savedVars.wrxCoord = value 
		Winter:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, RoseGuilds.savedVars.wrxCoord, 10)
		end,
        min = 0,
        max = GuiRoot:GetWidth(),
        step = 1,
        width = "full",
    })
LAM:RegisterOptionControls(panelName, optionsData)

--Menu	
local RoseGuildsMenuChat = WINDOW_MANAGER:CreateControl("RoseGuildsMenuChat", ZO_ChatWindow, CT_BUTTON)
      RoseGuildsMenuChat:SetDimensions(30, 30)
      RoseGuildsMenuChat:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, RoseGuilds.savedVars.xCoord, 8)
      RoseGuildsMenuChat:SetHandler("OnMouseEnter", function(control) InitializeTooltip(InformationTooltip, control) SetTooltipText(InformationTooltip, "|cFFFFFFRoseGuilds Menu|r") end)
      RoseGuildsMenuChat:SetHandler("OnMouseExit", function(control) ClearTooltip(InformationTooltip) end)
      RoseGuildsMenuChat:SetHandler("OnMouseUp", function(contol, button, upInside)
	  if button == MOUSE_BUTTON_INDEX_RIGHT and upInside then MidnightHall() end 
	  end)
      RoseGuildsMenuChat:SetNormalTexture("RoseGuilds/imgs/RoseGuilds.dds")
	  RoseGuildsMenuChat:SetHandler("OnClicked", function(...)
	  RoseGuildsMenuChat:SetHidden(RoseGuilds.savedVars.RoseMenu)
local RoseGuilds =
{	
{ label = "|cFFFFFFJoin |c6a5acdMidnight Rose", callback = function() ZO_LinkHandler_OnLinkClicked("|H1:guild:586676|hMidnight|h", 1) end, },
{ label = "|cFFFFFFJoin |c1E90FFWinter Rose", callback = function() ZO_LinkHandler_OnLinkClicked("|H1:guild:422980|hWinter|h", 1) end, },
{ label = "|cFFFFFFJoin |c00ff7fSpring Rose", callback = function() ZO_LinkHandler_OnLinkClicked("|H1:guild:496448|hSpring Rose|h", 1) end, },
{ label = "|cFFFFFFJoin |cf10000Summer Rose", callback = function() ZO_LinkHandler_OnLinkClicked("|H1:guild:569338|hSummer Rose|h", 1) end, },
{ label = "|cFFFFFFJoin |cff4500Autumn Rose", callback = function() ZO_LinkHandler_OnLinkClicked("|H1:guild:553666|hAutumn Rose|h", 1) end, },
}
local Guildhalls = 
{	
{ label = "|cFFFFFFVisit |c6a5acdQueenMisi's Guildhall", callback = function() MidnightHall() end, },
{ label = "|cFFFFFFVisit |c00ff7fQueenMisi's Guildhall", callback = function() SpringHall() end, },
{ label = "|cFFFFFFVisit |cf10000SuriValkyrie's Guildhall", callback = function() SummerHall() end, },
{ label = "|cFFFFFFVisit |cff4500Kay.Cee's Guildhall", callback = function() AutumnHall() end, },
{ label = "|cFFFFFFVisit |c1E90FFBellaBlithely's Guildhall", callback = function() WinterHall() end, },
}
local Traders =
{
{ label = "|c6a5acdMidnight |cFFFFFF- Windhelm, Eastmarch", callback = function() FastTravelToNode(87) end, },
{ label = "|c1E90FFWinter |cFFFFFF- Windhelm, Eastmarch", callback = function() FastTravelToNode(87) end, },
{ label = "|c00ff7fSpring |cFFFFFF- Windhelm, Eastmarch", callback = function() FastTravelToNode(87) end, },
{ label = "|cf10000Summer |cFFFFFF- Windhelm, Eastmarch", callback = function() FastTravelToNode(87) end, },
{ label = "|cff4500Autumn |cFFFFFF- Windhelm, Eastmarch", callback = function() FastTravelToNode(87) end, },
{ label = "|cF10000Wayshrine cost applies!", callback = function() d("|cf10000Travel cost") d(GetRecallCost(87)) end, },
}
ClearMenu()
AddCustomSubMenuItem("|c6a5abdRose |cFFFFFFGuilds", RoseGuilds)
AddCustomSubMenuItem("|c1E90FFRose |cFFFFFFGuild Halls", Guildhalls)
AddCustomSubMenuItem("|c00ff7fRose |cFFFFFFTraders", Traders)
AddCustomMenuItem("|cf10000Rose |cFFFFFFYoutube", function() RequestOpenUnsafeURL("https://www.youtube.com/@Roseguilds") end)
AddCustomMenuItem("|cff4500Rose |cFFFFFFDiscord", function() RequestOpenUnsafeURL("https://discord.gg/roseguilds") end)
AddCustomMenuItem("|c0000ffCrown Trading |cFFFFFFDiscord", function() RequestOpenUnsafeURL("https://discord.gg/kEgFrNW") end)
ShowMenu()
end)
--Menu (Guild Screen)	
local RoseGuildsMenuGuild =  WINDOW_MANAGER:CreateControl("RoseGuildsMenuGuild", ZO_GuildHome, CT_BUTTON)
      RoseGuildsMenuGuild:SetDimensions(80, 80)
      RoseGuildsMenuGuild:SetAnchor(TOPLEFT, ZO_GuildHome, nil, 350, 0)
	  RoseGuildsMenuGuild:SetHandler("OnMouseEnter", function(control) InitializeTooltip(InformationTooltip, control) SetTooltipText(InformationTooltip, "|ce036ffRoseGuilds |cFFFFFFMenu|r") end)
	  RoseGuildsMenuGuild:SetHandler("OnMouseExit", function(control) ClearTooltip(InformationTooltip) end)
	  RoseGuildsMenuGuild:SetHandler("OnMouseUp", function(contol, button, upInside)
	  if button == MOUSE_BUTTON_INDEX_RIGHT and upInside then MidnightHall() end 
	  end)
	  RoseGuildsMenuGuild:SetNormalTexture("RoseGuilds/imgs/RoseGuilds.dds")
	  RoseGuildsMenuGuild:SetHandler("OnClicked", function(...)
local RoseGuilds =
{	
{ label = "|cFFFFFFJoin |c6a5acdMidnight Rose", callback = function() ZO_LinkHandler_OnLinkClicked("|H1:guild:586676|hMidnight|h", 1) end, },
{ label = "|cFFFFFFJoin |c1E90FFWinter Rose", callback = function() ZO_LinkHandler_OnLinkClicked("|H1:guild:422980|hWinter|h", 1) end, },
{ label = "|cFFFFFFJoin |c00ff7fSpring Rose", callback = function() ZO_LinkHandler_OnLinkClicked("|H1:guild:496448|hSpring Rose|h", 1) end, },
{ label = "|cFFFFFFJoin |cf10000Summer Rose", callback = function() ZO_LinkHandler_OnLinkClicked("|H1:guild:569338|hSummer Rose|h", 1) end, },
{ label = "|cFFFFFFJoin |cff4500Autumn Rose", callback = function() ZO_LinkHandler_OnLinkClicked("|H1:guild:553666|hAutumn Rose|h", 1) end, },
}
local Guildhalls = 
{	
{ label = "|cFFFFFFVisit |c6a5acdQueenMisi's Guildhall", callback = function() MidnightHall() end, },
{ label = "|cFFFFFFVisit |c00ff7fQueenMisi's Guildhall", callback = function() SpringHall() end, },
{ label = "|cFFFFFFVisit |cf10000SuriValkyrie's Guildhall", callback = function() SummerHall() end, },
{ label = "|cFFFFFFVisit |cff4500Kay.Cee's Guildhall", callback = function() AutumnHall() end, },
{ label = "|cFFFFFFVisit |c1E90FFBellaBlithely's Guildhall", callback = function() WinterHall() end, },
}
local Traders =
{
{ label = "|c6a5acdMidnight |cFFFFFF- Windhelm, Eastmarch", callback = function() FastTravelToNode(87) end, },
{ label = "|c1E90FFWinter |cFFFFFF- Windhelm, Eastmarch", callback = function() FastTravelToNode(87) end, },
{ label = "|c00ff7fSpring |cFFFFFF- Windhelm, Eastmarch", callback = function() FastTravelToNode(87) end, },
{ label = "|cf10000Summer |cFFFFFF- Windhelm, Eastmarch", callback = function() FastTravelToNode(87) end, },
{ label = "|cff4500Autumn |cFFFFFF- Windhelm, Eastmarch", callback = function() FastTravelToNode(87) end, },
{ label = "|cF10000Wayshrine cost applies!", callback = function() d("|cf10000Travel cost") d(GetRecallCost(87)) end, },
}
ClearMenu()
AddCustomSubMenuItem("|c6a5abdRose |cFFFFFFGuilds", RoseGuilds)
AddCustomSubMenuItem("|c1E90FFRose |cFFFFFFGuild Halls", Guildhalls)
AddCustomSubMenuItem("|c00ff7fRose |cFFFFFFTraders", Traders)
AddCustomMenuItem("|cf10000Rose |cFFFFFFYoutube", function() RequestOpenUnsafeURL("https://www.youtube.com/@Roseguilds") end)
AddCustomMenuItem("|cff4500Rose |cFFFFFFDiscord", function() RequestOpenUnsafeURL("https://discord.gg/roseguilds") end)
AddCustomMenuItem("|c0000ffCrown Trading |cFFFFFFDiscord", function() RequestOpenUnsafeURL("https://discord.gg/kEgFrNW") end)
ShowMenu()
end)
--Menu (Chat Bar Min)	
local RoseGuildsMenuChatVertical =  WINDOW_MANAGER:CreateControl("RoseGuildsMenuChatVertical", ZO_ChatWindowMinBar, CT_BUTTON)
      RoseGuildsMenuChatVertical:SetDimensions(30, 30)
      RoseGuildsMenuChatVertical:SetAnchor(TOPLEFT, ZO_ChatWindowMinBar, nil, 0, 225)
	  RoseGuildsMenuChatVertical:SetHandler("OnMouseEnter", function(control) InitializeTooltip(InformationTooltip, control) SetTooltipText(InformationTooltip, "|cFFFFFFRoseGuilds Menu|r") end)
	  RoseGuildsMenuChatVertical:SetHandler("OnMouseExit", function(control) ClearTooltip(InformationTooltip) end)
	  RoseGuildsMenuChatVertical:SetHandler("OnMouseUp", function(contol, button, upInside)
	  if button == MOUSE_BUTTON_INDEX_RIGHT and upInside then MidnightHall() end 
	  end)
	  RoseGuildsMenuChatVertical:SetNormalTexture("RoseGuilds/imgs/RoseGuilds.dds")
	  RoseGuildsMenuChatVertical:SetHandler("OnClicked", function(...)
local RoseGuilds =
{	
{ label = "|cFFFFFFJoin |c6a5acdMidnight Rose", callback = function() ZO_LinkHandler_OnLinkClicked("|H1:guild:586676|hMidnight|h", 1) end, },
{ label = "|cFFFFFFJoin |c1E90FFWinter Rose", callback = function() ZO_LinkHandler_OnLinkClicked("|H1:guild:422980|hWinter|h", 1) end, },
{ label = "|cFFFFFFJoin |c00ff7fSpring Rose", callback = function() ZO_LinkHandler_OnLinkClicked("|H1:guild:496448|hSpring Rose|h", 1) end, },
{ label = "|cFFFFFFJoin |cf10000Summer Rose", callback = function() ZO_LinkHandler_OnLinkClicked("|H1:guild:569338|hSummer Rose|h", 1) end, },
{ label = "|cFFFFFFJoin |cff4500Autumn Rose", callback = function() ZO_LinkHandler_OnLinkClicked("|H1:guild:553666|hAutumn Rose|h", 1) end, },
}
local Guildhalls = 
{	
{ label = "|cFFFFFFVisit |c6a5acdQueenMisi's Guildhall", callback = function() MidnightHall() end, },
{ label = "|cFFFFFFVisit |c00ff7fQueenMisi's Guildhall", callback = function() SpringHall() end, },
{ label = "|cFFFFFFVisit |cf10000SuriValkyrie's Guildhall", callback = function() SummerHall() end, },
{ label = "|cFFFFFFVisit |cff4500Kay.Cee's Guildhall", callback = function() AutumnHall() end, },
{ label = "|cFFFFFFVisit |c1E90FFBellaBlithely's Guildhall", callback = function() WinterHall() end, },
}
local Traders =
{
{ label = "|c6a5acdMidnight |cFFFFFF- Windhelm, Eastmarch", callback = function() FastTravelToNode(87) end, },
{ label = "|c1E90FFWinter |cFFFFFF- Windhelm, Eastmarch", callback = function() FastTravelToNode(87) end, },
{ label = "|c00ff7fSpring |cFFFFFF- Windhelm, Eastmarch", callback = function() FastTravelToNode(87) end, },
{ label = "|cf10000Summer |cFFFFFF- Windhelm, Eastmarch", callback = function() FastTravelToNode(87) end, },
{ label = "|cff4500Autumn |cFFFFFF- Windhelm, Eastmarch", callback = function() FastTravelToNode(87) end, },
{ label = "|cF10000Wayshrine cost applies!", callback = function() d("|cf10000Travel cost") d(GetRecallCost(87)) end, },
}
ClearMenu()
AddCustomSubMenuItem("|c6a5abdRose |cFFFFFFGuilds", RoseGuilds)
AddCustomSubMenuItem("|c1E90FFRose |cFFFFFFGuild Halls", Guildhalls)
AddCustomSubMenuItem("|c00ff7fRose |cFFFFFFTraders", Traders)
AddCustomMenuItem("|cf10000Rose |cFFFFFFYoutube", function() RequestOpenUnsafeURL("https://www.youtube.com/@roseguilds") end)
AddCustomMenuItem("|cff4500Rose |cFFFFFFDiscord", function() RequestOpenUnsafeURL("https://discord.gg/roseguilds") end)
AddCustomMenuItem("|c0000ffCrown Trading |cFFFFFFDiscord", function() RequestOpenUnsafeURL("https://discord.gg/kEgFrNW") end)
ShowMenu()
end)
--Discord
local RoseGuildsMenuGuild =  WINDOW_MANAGER:CreateControl("RoseGuildsMenuDiscord", ZO_GuildHome, CT_BUTTON)
      RoseGuildsMenuGuild:SetDimensions(100, 100)
      RoseGuildsMenuGuild:SetAnchor(TOPLEFT, ZO_GuildHome, nil, 435, 5)
	  RoseGuildsMenuGuild:SetHandler("OnMouseEnter", function(control) InitializeTooltip(InformationTooltip, control) SetTooltipText(InformationTooltip, "|ce036ffRose |cFFFFFFDiscord|r") end)
	  RoseGuildsMenuGuild:SetHandler("OnMouseExit", function(control) ClearTooltip(InformationTooltip) end)
	  RoseGuildsMenuGuild:SetNormalTexture("RoseGuilds/imgs/Discord.dds")
	  RoseGuildsMenuGuild:SetHandler("OnClicked", function(...) RequestOpenUnsafeURL("https://www.discord.gg/RoseGuilds") end)
	  RoseGuildsMenuGuild:SetHandler("OnMouseUp", function(contol, button, upInside)
	  if button == MOUSE_BUTTON_INDEX_RIGHT and upInside then RequestOpenUnsafeURL("https://discord.gg/kEgFrNW") end 
	  end)

ZO_CreateStringId("SI_BINDING_NAME_Midnight", "|c6a5acdMidnight's Hall|r")
ZO_CreateStringId("SI_BINDING_NAME_Spring", "|c00ff7fSpring's Hall|r")
ZO_CreateStringId("SI_BINDING_NAME_Summer", "|cf10000Summer's Hall|r")
ZO_CreateStringId("SI_BINDING_NAME_Autumn", "|cff4500Autumn's Hall|r")
ZO_CreateStringId("SI_BINDING_NAME_Winter", "|c1E90FFWinter's Hall|r")
end

function RoseGuilds.OnAddOnLoaded(event, addonName) 
	if addonName ~= RoseGuilds.name then return end
	RoseGuilds.savedVars = ZO_SavedVars:New("RoseGuildsSavedVariables", 2, nil, RoseGuilds.savedVars)
	EVENT_MANAGER:UnregisterForEvent(RoseGuilds.name, EVENT_ADD_ON_LOADED)	
end

--Keybinds
function Keybinds()
	d("Midnight: " .. GetString(SI_BINDING_NAME_Midnight))
	d("Spring: " .. GetString(SI_BINDING_NAME_Spring))
	d("Summer: " .. GetString(SI_BINDING_NAME_Summer))
	d("Autumn: " .. GetString(SI_BINDING_NAME_Autumn))
	d("Winter: " .. GetString(SI_BINDING_NAME_Winter))
	d("Keybinding Layer: " .. GetString(SI_KEYBINDINGS_LAYER_GENERAL))
end

EVENT_MANAGER:RegisterForEvent("SharedMembers", EVENT_PLAYER_ACTIVATED, function()
    local guildMembers = {}

    for i = 1, GetNumGuilds() do
        local guildId = GetGuildId(i)
        local numMembers = GetNumGuildMembers(guildId)

        for j = 1, numMembers do
            local displayName, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _ = GetGuildMemberInfo(guildId, j)
            
            local rank = GetGuildRankCustomName(guildId, 1)
            if rank ~= "|c604fc9GMisi" and rank ~= "|c186a3bGM" and rank ~= "|cF8C300GM" and rank ~= "|cff4500GM" and rank ~= "|c1E90FFGM" and rank ~= "|c6a5acdAdmin" and rank ~= "|c1d8348Admin" and rank ~= "|cDC143CAdmin" and rank ~= "|cff591fAdmin" and rank ~= "|c379CFFAdmin" and rank ~= "|c7163cfOfficer" and rank ~= "|c239b56Officer" and rank ~= "|cDC143COfficer" and rank ~= "|cff6a34Officer" and rank ~= "|c50A9FFOfficer" and rank ~= "|c8376d5Officer" and rank ~= "|c28b463Officer" and rank ~= "|cDC143COfficer" and rank ~= "|cff7948Officer" and rank ~= "|c69B5FFOfficer" then
                guildMembers[displayName] = guildMembers[displayName] or {}
                table.insert(guildMembers[displayName], GetGuildName(guildId))
            end
        end
    end

    SLASH_COMMANDS["/sharedguilds"] = function()
        local sharedMembers = {}
        for memberName, guildList in pairs(guildMembers) do
            if #guildList > 1 then
                local guildNames = table.concat(guildList, ", ")
                table.insert(sharedMembers, memberName .. " (" .. guildNames .. ")")
            end
        end

        if #sharedMembers > 0 then
            local memberList = table.concat(sharedMembers, "\n")
            d("You share more than one guild with the following players:\n" .. memberList)
        else
            d("You don't share more than one guild with any other players.")
        end
    end
end)

EVENT_MANAGER:RegisterForEvent("RoseGuildsLoaded", EVENT_ADD_ON_LOADED, function(...) 	RoseGuilds_Initialize(...) 	end)